// AlertTest.cpp : main source file for AlertTest.exe
//

#include "stdafx.h"

#include <atlframe.h>
#include <atlctrls.h>
#include <atldlgs.h>
#include <atlfile.h>
#include <atlenc.h>
#include "resource.h"

#include "aboutdlg.h"
#include "MainDlg.h"
#include "AppCommon.h"

CAppModule _Module;

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWDEFAULT)
{
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

	CMainDlg dlgMain;

	if(dlgMain.Create(NULL) == NULL)
	{
		ATLTRACE(_T("C_CAO̍쐬Ɏs܂!\n"));
		return 0;
	}

	dlgMain.ShowWindow(nCmdShow);

	int nRet = theLoop.Run();

	_Module.RemoveMessageLoop();
	return nRet;
}
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

	// this resolves ATL window thunking problem when Microsoft Layer for Unicode (MSLU) is used
	::DefWindowProc(NULL, 0, 0, 0L);

	AtlInitCommonControls(ICC_BAR_CLASSES);	// add flags to support other controls

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	::CoUninitialize();

	return nRet;
}

int CMainDlg::loadIniFile()
{
	// init@C̒gǂݍ
	fForkServer = GetPrivateProfileInt(_T("SERVER"), _T("AutoStart"), TRUE, INI_FILE_NAME);
	fShowServer = GetPrivateProfileInt(_T("SERVER"), _T("ShowServer"), FALSE, INI_FILE_NAME);
	int port = GetPrivateProfileInt(_T("CLIENT"), _T("Port"), 11111, INI_FILE_NAME);
	sPort = htons(port);
	return ERR_SUCCESS;
}

int CMainDlg::sendToServer()
{	
	USES_CONVERSION;
	char *buf;

	// Winsock
	WSADATA wsaData;
	if(WSAStartup(MAKEWORD(2, 0), &wsaData) != 0)
	{
		dwLastError = WSAGetLastError();
		return ERR_WSASTARTUP;
	}

	// \Pbg̍쐬
	SOCKET sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock == INVALID_SOCKET)
	{
		return ERR_INVALID_SOCKET;
	}

	// ڑ̎擾
	CEdit hostInput = GetDlgItem(IDC_EDIT2);
	TCHAR _buf2[256];
	hostInput.GetWindowText(_buf2, sizeof(_buf2));
	buf = T2A(_buf2);
	
	// ڑJn
	int connectResult = connectServer(buf, sPort, &sock);
	if(connectResult != ERR_SUCCESS)
	{
		return connectResult;
	}

	// Me̎擾
	CEdit edit = GetDlgItem(IDC_EDIT1);
	TCHAR _buf[256];
	int len = edit.GetWindowText(_buf, sizeof(_buf));

	char *buff;
	int nLen;
	// MeUTF-8ɕϊ
#ifdef _UNICODE
	nLen = AtlUnicodeToUTF8(_buf, len, NULL, 0);
	buff = new char[nLen + 1];
	nLen = AtlUnicodeToUTF8(_buf, len, buff, nLen + 1);
#else
	buff = _buf;
	nLen = len;
#endif

	// M
	int snd = send(sock, buff, nLen, 0);
	if(snd < 0)
	{
		dwLastError = WSAGetLastError();
		return ERR_SEND;
	}

	// ڑI
	closesocket(sock);
	WSACleanup();

	return ERR_SUCCESS;
}

// T[oւ̐ڑ(zXgIPւ̕ϊ@\)
int CMainDlg::connectServer(char *hostname, u_short port, SOCKET *sock)
{
	struct sockaddr_in server;
	server.sin_family = AF_INET;
	server.sin_port = port;
	server.sin_addr.S_un.S_addr = inet_addr(hostname);
	if(server.sin_addr.S_un.S_addr == 0xffffffff)
	{
		struct hostent *host;
		host = gethostbyname(hostname);
		if(host == NULL)
		{
			return ERR_GETHOSTBYNAME;
		}

		unsigned int **addrptr = (unsigned int **) host->h_addr_list;

		while(*addrptr != NULL)
		{
			server.sin_addr.S_un.S_addr = *(*addrptr);

			if(connect(*sock, (struct sockaddr *) &server, sizeof(server)) != 0)
			{
				break;
			}
			 addrptr++;
		}

		if(*addrptr == NULL)
		{
			return ERR_ALLHOST_DENY;
		}
	}else{
		if(connect(*sock, (struct sockaddr *) &server, sizeof(server)) != 0)
		{
			return ERR_IP_DENY;
		}
	}
	return ERR_SUCCESS;
}

int CMainDlg::loadResult()
{
	// eLXgt@C̓ǂݍ
	CAtlFile af;
	HRESULT hr;
	ULONGLONG nLen;
	hr = af.Create(RESULT_LOG_FNAME, GENERIC_READ, FILE_SHARE_READ, OPEN_EXISTING);
	if(FAILED(hr))
	{
		return ERR_FILE_NOT_FOUND;
	}

	hr = af.GetSize(nLen);
	if(SUCCEEDED(hr))
	{
		char *buff;
		buff = new char[(DWORD)nLen + 1];
		if(buff)
		{
			hr = af.Read(buff, (DWORD) nLen);
			if(FAILED(hr))
			{
				return ERR_FILE_LOAD;
			}
			
			// UTF-8UNICODEɕϊ
			TCHAR *_buff;
#ifdef _UNICODE
			int len = MultiByteToWideChar(CP_UTF8, MB_PRECOMPOSED, buff, (DWORD) nLen, NULL, 0);
			_buff = new TCHAR[len + 1];
			int llen = MultiByteToWideChar(CP_UTF8, MB_PRECOMPOSED, buff, (DWORD) nLen, _buff, len);
			_buff[len] = '\0';
#else
			_buff = buff;
#endif

			CEdit edit = GetDlgItem(IDC_EDIT1);
			edit.SetWindowText(_buff);
			delete(_buff);
			delete(buff);
		}
	}

	af.Close();
	return ERR_SUCCESS;
}

int CMainDlg::forkServerProcess()
{
	// T[ovZXN邩ǂ
	if(!fForkServer)
	{
		return -1;
	}

	// R}hCgݗ
	TCHAR cmdLine[256];
	_stprintf(cmdLine, _T("AlertServer.bat"));

	int showConsole = SW_HIDE;
	if(fShowServer)
	{
		showConsole = SW_SHOW;
	}

	int forked = (int) ShellExecute(NULL, NULL, cmdLine, NULL, NULL, showConsole);
	if(forked < 32)
	{
		dwLastError = forked;
		return ERR_FORK;
	}

	return ERR_SUCCESS;
}

